---

- name: Look up existing template
  community.general.postgresql_query:
    db: debusine
    query: >
      SELECT t.task_name, t.task_data
        FROM db_workflowtemplate AS t
        JOIN db_workspace AS w ON t.workspace_id = w.id
        JOIN db_scope AS s ON w.scope_id = s.id
        WHERE s.name || '/' || w.name = %(workspace)s AND t.name = %(name)s;
    named_args:
      name: "{{ debusine_workflow_template_name }}"
      workspace: "{{ debusine_workflow_template_workspace | default('debusine/System') }}"
    login_user: debusine-server
  become: true
  become_user: debusine-server
  check_mode: false
  changed_when: false
  register: current_template

- name: Create workflow template
  when: >
    current_template.rowcount < 1
    or current_template.query_result[0].task_name != debusine_workflow_template_task
    or current_template.query_result[0].task_data != debusine_workflow_template_data
  community.general.postgresql_query:
    db: debusine
    query: >
      INSERT INTO db_workflowtemplate (name, task_name, task_data, workspace_id, priority)
        VALUES (
          %(name)s,
          %(task)s,
          %(data)s,
          (SELECT w.id FROM db_workspace AS w JOIN db_scope AS s ON w.scope_id = s.id WHERE s.name || '/' || w.name = %(workspace)s),
          0
        )
        ON CONFLICT (name, workspace_id)
        DO UPDATE SET task_name = %(task)s, task_data = %(data)s;
    named_args:
      name: "{{ debusine_workflow_template_name }}"
      task: "{{ debusine_workflow_template_task }}"
      data: "{{ debusine_workflow_template_data | to_json }}"
      workspace: "{{ debusine_workflow_template_workspace | default('debusine/System') }}"
    login_user: debusine-server
  become: true
  become_user: debusine-server
